/************************************************************/
/*                                                          */
/*  H8SX/1653 Sample                                        */
/*  s, USBfoCXƂĔF                     */
/*                                                          */
/************************************************************/

#include    <machine.h>
#include    <string.h>
#include    <stdlib.h>
#include    "1653.h"
#include    "mondef.h"
#include    "USBDEF.h"									// USB֘Aht@C

/************************************************************/
/*  Function define                                         */
/************************************************************/
void init ( void );
void main ( void );
void rxi4_int ( void );
void txi4_int ( void );
void eri4_int ( void );
void tei4_int ( void );
void usbintn0_intr ( void );
void usbintn1_intr ( void );
void usbintn2_intr ( void );
void usbintn3_intr ( void );
void resume_intr ( void );

/************************************************************/
/*  Vector Address                                          */
/************************************************************/
#pragma entry init(sp=0xFFC000,vect=0)                      /* H'0000 : Reset                   */
#pragma interrupt (eri4_int(vect=160))                      /* H'0280 : Receive error           */
#pragma interrupt (rxi4_int(vect=161))                      /* H'0284 : Receive data full       */
#pragma interrupt (txi4_int(vect=162))                      /* H'0288 : Transmit data empty     */
#pragma interrupt (tei4_int(vect=163))                      /* H'028C : Transmit end            */
#pragma interrupt (usbintn0_intr(vect=232))                 /* H'03A0 : EP1FIFOt */
#pragma interrupt (usbintn1_intr(vect=233))                 /* H'03A4 : EP2FIFOGveB */
#pragma interrupt (usbintn2_intr(vect=234))                 /* H'03A8 : USB, ݗv͑I */
#pragma interrupt (usbintn3_intr(vect=235))                 /* H'03AC : USB, ݗv͑I */
#pragma interrupt (resume_intr(vect=238))                   /* H'03B8 : USBW[ */


// gp֐̐錾
void	 main_ram ( void );
void	t1ms(short dat);								// dat ms̎ԑ҂֐
void	t5us(void);										// 5us̎ԑ҂֐
void	t50us(void);									// 50us̎ԑ҂֐
void	init_sci0(void);								// SCI0̏, SDJ[hg
void	init_sci1(void);
unsigned char	OI_DAT0(unsigned char d);				// SCI0 1M, 1M
void	out_cmd(unsigned char cmd, unsigned long addr);	// SDJ[h̃R}h̔s
unsigned char in_res(void);								// SDJ[hR1
unsigned char in_res_1(void);							// SDJ[h̉
char	wr_SD(unsigned long addr);						// SDJ[h̃ZN^
void	wrm_SD(unsigned long addr, unsigned short Num);

// @֐vg^Cv`
void	rx_0(void);										// ENDP0ւ̎M
void	rx_setup(void);									// ZbgAbvpPbgւ̎M
void	rx_1(void);										// ENDP1ւ̎M
void  tx_0(void);										// ENDP0̑M

void  senddesc(void);									// fXNv^̑M
void  getdescriptor(void);								// fXNv^擾̏
void  sendstring(void);									// XgOf[^̑M

void	init_SD(void);									// SDJ[h̏
char	rd_SD(unsigned long addr);						// SDJ[h̃ZN^Ǎ

#define CS_SD PD.DR.BIT.B1								// SDJ[hCS[q̒`

#pragma section ramdat									// ϐZNV̒`
unsigned char   rcv_dat1[16384];
unsigned char	SD_DAT[514];          					// SDJ[h̃ZN^f[^pobt@
unsigned char	SETUP_DAT[16];          				// ZbgAbvf[^Mpobt@
unsigned char   rx_dat1[64];							// ENDP1̎Mf[^p
unsigned char   tx_dat2[64];							// ENDP2̑Mf[^p

#pragma section
// USBO[oϐ
static int      DESC_INDEX;         					// fBXNv^|C^
static int      DESC_SIZE;          					// fBXNv^TCY
static int      GETDESC;								// fXNv^擾tO

#pragma section                                             /* P                                */
/************************************************************/
/*  Initialize Program                                      */
/************************************************************/
void init ( void )
{
    set_ccr(0x80);                                          /* Initialize CCR/Interrupt Disable */
    SCKCR.WORD = 0x0000;                                    /* MD_CLK=0 Iphi,Pphi,Bphi=x4,x4,x4 */

    MSTP.CRA.WORD = 0x0FFF;                                 /* Cancel the module stop mode      */
    MSTP.CRB.WORD = 0xECFF;
    MSTP.CRC.WORD = 0xFE00;

    main();

    while(1);
}

/************************************************************/
/*  Main Program                                            */
/************************************************************/
void main ( void )
{
    unsigned char   tmp, tmp0;
    unsigned char   i;

	init_sci4();


    main_ram();
	while (1);
}

/************************************************************/
/*  RAM̃C[`                                   */
/************************************************************/
void main_ram ( void )
{
    unsigned char   tmp;								// ꎞIϐ, ėpɎg
	int i;
	unsigned long j;

    MSTP.CRC.WORD = 0x0300;								// USBW[L
    MSTP.CRB.WORD = 0x683f;								// SCI4W[L

	PD.DDR = 0x2;										// PD1 = OUT for CS_SD
	CS_SD = 1;											// PD1 = CS = 1

	init_sci0();										// SCI0̏, SDp

	t1ms(50);											// 50ms҂
	init_SD();											// SDJ[h̏

	for (i = 0; i < 50; i++)							// eENDP̑ݒ
	{
		USB.EPIR = endp_data[i];
	}

	USB.DMA.BIT.PULLUP_E = 1;							// D+vAbv
	tmp = USB.IER0.BYTE;								// IER0̃_~[Ǎ
	USB.IER0.BIT.BRST = 1;								// oXZbgݗL
	USB.IER0.BIT.SETUP_TS = 1;							// SETUPR}hMݗL
	USB.IER0.BIT.EP0o_TS = 1;							// EP0oMݗL
	USB.IER0.BIT.EP0i_TS = 1;							// EP0iMݗL
	USB.IER0.BIT.EP1_FULL = 1;							// EP1FIFOtݗL
	tmp = USB.IER1.BYTE;								// IER1̃_~[Ǎ
	USB.IER1.BIT.VBUSF = 1;								// USBoXڑݗL
	USB.TRG.BYTE = 0x26;								// TRGWX^̏

    set_imask_ccr(0);                                       /* Enable interrupt                 */
	while(1);
}

/******************************************************************
*   SDJ[h̏ݒB                                          *
*   @̓AhX                                              *
*     I; 0, I; -1                               *
******************************************************************/
void	init_SD(void)
{
	unsigned char i, tmp;
	
	for (i = 0; i < 10; i++)							// V[PX
	{
		tmp = OI_DAT0(0xff);
	}

	CS_SD = 0;

	out_cmd(0x00, 0x00);								// GO_IDLE_STATE
	if (in_res() != 0x1)								// R11ȊOȂ
	{
		OUT_DAT4(0x35);									// for monitor
	}

	while(1)											// SEND_OP_CONDR10ɂȂ܂ŌJԂ
	{
		out_cmd(0x01, 0x00);							// SEND_OP_COND
		if (in_res() == 0x0)							// R10()ɂȂ甲
		{
			break;
		}
	}

	CS_SD = 1;

    SCI0.BRR = 0;                                 		// N = 48MHz/4/12MHz - 1 = 0(CLK12MHzɃAbv)
	t50us();
}

/******************************************************************
*   SDJ[h̃ZN^Ǎ݁B                                      *
*   @̓AhX                                              *
*     I; 0, I; -1                               *
******************************************************************/
char rd_SD(unsigned long addr)
{
	unsigned char tmp;
	int i;
	
	CS_SD = 0;

	out_cmd(0x11, addr);								// READ_SINGLE_BLOCK
	if (in_res() != 0x0)								// R10ȊOȂُI
	{
		OUT_DAT4(0x57);									// for monitor
		return -1;										// ُI
	}

	while(1)											// ҂, JԂׂ
	{
		tmp = OI_DAT0(0xff);							// 0xfeɂȂ珀
		if (tmp == 0xfe)
		{
			break;
		}
	}


	for (i = 0; i < 514; i++)							// Data(512) + CRC16
	{
		SD_DAT[i] = OI_DAT0(0xff);						// ZN^f[^SD_DAT[]ɓ]
	}

	CS_SD = 1;
	return 0;											// I
}


/******************************************************************
*   SDJ[h̃ZN^݁B                                      *
*@   ̓AhX                                              *
*     I; 0, I; -1                               *
******************************************************************/
char wr_SD(unsigned long addr)
{
	unsigned char	tmp;
	int	i;

	out_cmd(0x18, addr);								// WRITE_BLOCK
	if (in_res() != 0x0)								// R10ȊOȂُI
	{
		OUT_DAT4(0x58);									// for monitor
		return -1;										// ُI
	}

	tmp = OI_DAT0(0xfe);								// f[^]X^[g
	for (i = 0; i < 512; i++)
	{
		tmp = OI_DAT0(i);
	}
	tmp = OI_DAT0(0x55);								// CRC16̃_~[]
	tmp = OI_DAT0(0x55);								// CRC16̃_~[]

	if ((in_res() & 0xf) != 0x5)						// R1x5hȊOȂُI
	{
		OUT_DAT4(0x59);									// for monitor
		return -1;										// ُI
	}

	while(in_res_1() == 0x0);							// fBXe[^X(FFh)܂ő҂
	CS_SD = 1;
	return 0;											// I
}

/******************************************************************
*   SDJ[h̃R}hsB                                      *
*@   ̓R}h, 2̓AhX                       *
******************************************************************/
void	out_cmd(unsigned char cmd, unsigned long addr)
{
	unsigned char	tmp;
	
	cmd |= 0x40;										// Host = 1
	CS_SD = 0;
	tmp = OI_DAT0(0xff);								// _~[
	tmp = OI_DAT0(cmd);									// R}hs
	tmp = OI_DAT0(addr >> 24);							// AhXMSB
	tmp = OI_DAT0(addr >> 16);							// AhX
	tmp = OI_DAT0(addr >> 8);							// AhX
	tmp = OI_DAT0(addr);								// AhXLSB
	tmp = OI_DAT0(0x95);								// CRC̃_~[
}

/******************************************************************
*   SDJ[h̉҂[`                                *
*@   FFhȊOɂȂ܂Ń[v                               *
******************************************************************/
unsigned char in_res(void)
{
unsigned char tmp;

	while(1)
	{
		tmp = OI_DAT0(0xff);
		if (tmp != 0xff)
		{
			return tmp;
		}
	}
}

/******************************************************************
*   SDJ[h̉҂[`                                *
*@   擾璼Ƀ^[                              *
******************************************************************/
unsigned char in_res_1(void)
{
	return OI_DAT0(0xff);
}

/******************************************************************
*   SCI0̏(SDJ[hg)@                                *
******************************************************************/
void	init_sci0(void)
{
	int i;
	unsigned char tmp;
	
	SCI0.SCR.BYTE &= 0x00;								// TE,RE 0 clear
	P2.ICR.BIT.B1 = 1;									// P21(RxD0)̐ݒ
	SCI0.SCR.BYTE = 0x00;								// CKE1,0 = 00, SCK0 OUT
	SCI0.SCMR.BYTE = 0xfa;								// 1111, MSB first, 010(for SCD)
	SCI0.SMR.BYTE = 0x80;								// CLK, -----, CKS1,0 = 00 Pphi
	SCI0.BRR = 29;										// N = 48MHz/4/400kHz-1 = 29
	t50us();											// 1bit time Wait
	t50us();											// 1bit time Wait
	t50us();											// 1bit time Wait

	tmp = SCI0.SSR.BYTE;								// SSR̃_~[Ǎ
	SCI0.SSR.BYTE &= 0x87;								// SSR RDRF,ORER,PER,FER = 0 clear

	SCI0.SCR.BYTE = 0x30;								// Set TE,RE bit
}

/******************************************************************
*   SCI0 1M, 1M                               *
*     ͑Mf[^, ^[͎Mf[^                      *
******************************************************************/
unsigned char OI_DAT0(unsigned char d)
{
	unsigned char tmp;

	while(SCI0.SSR.BIT.TDRE == 0);

	SCI0.TDR = d; 										// WRITE DATA TO TDR
	SCI0.SSR.BIT.TDRE = 0;								// CLEAR TDRE

	while ((SCI0.SSR.BYTE & 0x78) == 0);
	if ((SCI0.SSR.BYTE & 0x40) != 0)
	{
		SCI0.SSR.BIT.RDRF = 0;							// CLEAR RDRF
		return SCI0.RDR;								// Mf[^^[
	}
	else
	{													// s
		OUT_DAT4(SCI0.SSR.BYTE);						// for@monitor
		SCI0.SSR.BYTE = 0x80;							// CLEAR ERR FLAG
		return 0;										// 0^[
	}
}

/******************************************************************
*   EP1FIFOt                                             *
******************************************************************/
void usbintn0_intr ( void )
{
}

/******************************************************************
*   EP2FIFOGveB                                       *
******************************************************************/
void usbintn1_intr ( void )
{
}

/******************************************************************
*   USB, ݗv͑I                                   *
******************************************************************/
void usbintn2_intr ( void )
{
    unsigned char   tmp;
	int	i;

	if (USB.IFR0.BIT.BRST == 1)							// oXZbgH
	{
		USB.IFR0.BIT.BRST = 0;							// tONA
		USB.FCLR.BYTE = 0xff;							// 
	}
	else if (USB.IFR0.BIT.SETUP_TS == 1)				// ZbgAbvR}hM݁H
	{
		USB.IFR0.BIT.SETUP_TS = 0;						// tONA
		rx_setup();										// ZbgAbvR}hM
	}
	else if (USB.IFR0.BIT.EP0o_TS == 1)					// EP0oM݁H
	{
		USB.IFR0.BIT.EP0o_TS = 0;						// tONA
		rx_0();											// EP0oM
	}
	else if (USB.IFR0.BIT.EP0i_TS == 1)					// EP0iM݁H
	{
		USB.IFR0.BIT.EP0i_TS = 0;						// tONA
		tx_0();											// EP0iM
	}
	else if (USB.IFR0.BIT.EP1_FULL == 1)				// EP1FIFOt
	{
		rx_1();											// rx_1M
	}
}

/******************************************************************
*   USB, ݗv͑I                                   *
******************************************************************/
void usbintn3_intr ( void )
{
    unsigned char   tmp; //, rcv_dat;

	tmp = USB.IFR1.BYTE;								// IFR1WX^̃_~[Ǎ
	USB.IFR1.BIT.VBUSF = 0;								// USBؒfo
}

/******************************************************************
*   USBW[                                           *
******************************************************************/
void resume_intr ( void )
{
}

/******************************************************************
*   EP1FIFOtM݃Cxg̏                          *
******************************************************************/
void  rx_1(void)
{
    int     i, j, tmp;

	tmp = USB.EPSZ1;									// Mf[^̎擾
	for (i = 0; i < tmp; i++)							// Mf[^rx_dat[]֓]
	{
		rx_dat1[i] = USB.EPDR1;
	}
	USB.TRG.BIT.EP1_RDFN = 1;							// EP1Ǐo
}

/******************************************************************
*   EP0ZbgAbvM݃Cxg̏                      *
******************************************************************/
void  rx_setup(void)
{
    int     rxstat,dumy;
	int	i;

	USB.FCLR.BIT.EP0i_CLR = 1;							// EP0iNA
	USB.FCLR.BIT.EP0o_CLR = 1;							// EP0oNA
	for (i = 0 ; i < 8; i++)
	{
		SETUP_DAT[i] = USB.EPDR0s;						// ZbgAbvR}hSETUP_DAT[]ɓ]
	}
	USB.TRG.BIT.EP0s_RDFN = 1;							// EP0sǂݏo

	////////@SETUPJn@////////
	switch(SETUP_DAT[0] & 0x60)							// WNGXgH
	{
	case 0x0:
		switch(SETUP_DAT[1])							// WNGXg̊e
		{
		case GET_DESCRIPTOR: 
			getdescriptor();							// fXNv^擾̏
			break;  
		default: 
			break;										// unknown
		}
		break;
	case 0x20:											// NXNGXgH
		switch(SETUP_DAT[1])
		{
//		case	GET_REPORT:		getreport(); break;
//		case	GET_IDLE:		getidle(); break;
//		case	GET_PROTOCOL:	getprotocol(); break;
//		case	SET_REPORT:		setreport(); break;
//		case	SET_IDLE:		setidle(); break;
//		case	SET_PROTOCOL:	setprotocol(); break;
//		default:	break;
		}
    default:
		break;
	}
}

/******************************************************************
*   EP0oM                                                  *
******************************************************************/
void  rx_0(void)
{
int	i;

	if (USB.EPSZ0o == 0)								// Mf[^0H
	{
		GETDESC = 0;									// fXNv^MI
		USB.FCLR.BIT.EP0o_CLR;							// EP0oNA
		USB.TRG.BIT.EP0o_RDFN = 1;						// EP0oǂݏo
	}
}

/******************************************************************
*   EP0iM                                                  *
******************************************************************/
void tx_0(void)
{
	int     txstat;

	if(GETDESC != 0)									// fBXNv^MH
	{
		senddesc();										// fBXNv^̎̃ubNM
	}
}

/******************************************************************
*   @@@@@@@@@@@@@@@@@@@@@                    *
*   @@@@@@@@eNGXgɑ΂鏈                      *
*   @@@@@@@@@@@@@@@@@@@@@                    *
******************************************************************/

/******************************************************************
*   fXNv^M̏                                        *
******************************************************************/
void getdescriptor(void)
{
	int desc_type;

	GETDESC = 1;										// getdescriptor[hɐݒ
	desc_type = SETUP_DAT[3];							// fXNv^^Cv̎擾

	switch(desc_type)
	{
	case DEVICE:
		DESC_INDEX = DEV_DESC_OFS;
		DESC_SIZE = DEV_LENGTH;
		break;
	case CONFIGURATION:
		DESC_INDEX = CFG_DESC_OFS;
		DESC_SIZE = CFG_DESC_SIZE;
		break;
	case HID: 
		DESC_INDEX = HID_DESC_OFS;
		DESC_SIZE = HID_LENGTH;
		break;
	case HIDREPORT:
		DESC_INDEX = HIDREPORT_OFS;
//		DESC_SIZE = RPT_DESC_SIZE;						// HID͎̎w肷        
		break; 
	case INTERFACE:
		DESC_INDEX = IF_DESC_OFS;
		DESC_SIZE = INT_LENGTH;
		break;
	case XSTRING:
		sendstring();
		break;
	default: 
		DESC_INDEX = 0;
		DESC_SIZE=0;
		break;
	}
	if(SETUP_DAT[7] == 0)								// fXNv^TCY256𒴂ꍇ
	{
		if (DESC_SIZE > SETUP_DAT[6])
			DESC_SIZE = SETUP_DAT[6];
	}
	senddesc();											// send descriptor                 
}


/******************************************************************
*   senddesc ֐                                                 *
******************************************************************/
void senddesc(void)
{
	int dumy,i;


	if(DESC_SIZE > 8)									// c̃fXNv^TCY8oCgȏH
	{
		for (i = 0 ; i < 8; i++)
		{
			USB.EPDR0i = DEV_DESC[DESC_INDEX];			// ̃fXNv^8oCgEPDR0i֓]
			DESC_INDEX++;
		}
		DESC_SIZE = DESC_SIZE - 8;						// fXNv^TCY8oCg炷
	}
	else												// c̃fXNv^TCY8oCg菭ȂH
	{
		if(DESC_SIZE > 0)
		{
			for (i=0; i<DESC_SIZE; i++)
			{
				USB.EPDR0i = DEV_DESC[DESC_INDEX];		// c̃fXNv^EPDR0i֓]
				DESC_INDEX++;
			}
			DESC_SIZE = 0;								// c0
		}
	}
	USB.TRG.BIT.EP0s_RDFN = 1;							// EP0sǂݏo
	USB.TRG.BIT.EP0i_PKTE = 1;							// EP0ipPbgCl[u
}

/******************************************************************
*   XgOf[^̑M֐                                   *
******************************************************************/
void sendstring(void)
{
	int i,dumy;

	switch(SETUP_DAT[2])
	{
	case 0:												// Language String
		DESC_INDEX = STR_OFS;
		DESC_SIZE = LANG_SIZE;
		break;
	case 1:												// Manufacturing String
		DESC_INDEX = MFG_STR_OFS;
		DESC_SIZE = MFG_SIZE;
		break;
	case 2:												// Product String
		DESC_INDEX = PID_STR_OFS;
		DESC_SIZE = PID_SIZE;
		break;
	case 3:												// Serial Number String
		DESC_INDEX = NBR_STR_OFS;
		DESC_SIZE = NBR_SIZE;
		break;
	case 4:												// Configuration Stirng
		DESC_INDEX = CFG_STR_OFS;
		DESC_SIZE = CFG_SIZE;
		break;
	case 5:												// Inteface String
		DESC_INDEX = INT_STR_OFS;
		DESC_SIZE = INT_SIZE;
		break;
	default:
		DESC_INDEX = 0;
		DESC_SIZE = 0;
		break;
	}
}

/***************************************
  c ms҂ٰ
    ms̎ԑ҂[`
***************************************/
void	t1ms(short c)
{
	short	i, dummy;
	while (c--)
	{
		for (i=0; i<=9600; i++) dummy = i;
	}
}

/***************************************
  5us҂ٰ
***************************************/
void  t5us(void)
{
short i;
    i = 12;
    do (i--);
    while (i != 0);
}

/***************************************
  50us҂ٰ
***************************************/
void  t50us(void)
{
short i;
    i = 131;
    do (i--);
    while (i != 0);
}

void	init_sci4(void)
{
	int i;
	unsigned char tmp;
	
	SCI4.SCR.BYTE &= 0xCF;									/* TE,RE 0 clear                    */
    P6.ICR.BIT.B1 = 1;										/* P15(RxD5) Receive                */
    SCI4.SCR.BYTE |= 0x00;									/* CKE1,0=B'1X, External clock      */
    SCI4.SMR.BYTE = 0x00;									/* Set SMR                          */
    SCI4.SCMR.BYTE &= 0xF2;									/* SMIF = 0                         */
    SCI4.BRR = 12;											/* 115.2kbps 48MHz                     */
    for ( i = 0; i < 128; i++ );							/* 1bit time Wait                   */

    tmp = SCI4.SSR.BYTE;
    SCI4.SSR.BYTE &= 0x87;									/* SSR RDRF,ORER,PER,FER = 0 clear  */

    SCI4.SCR.BYTE = 0x70;									/* Set RIE,TE,RE bit       */
}

/*;---------- SCI4 1𑗐M ----------*/
void OUT_DAT4(unsigned char d)
{
	while(SCI4.SSR.BIT.TDRE == 0);
	SCI4.TDR = d;											/* WRITE DATA TO TRD */
	SCI4.SSR.BIT.TDRE = 0;									/* CLEAR TDRE */
}

/************************************************************/
/*  SCI_4 RXI4 Interrupt                                    */
/************************************************************/
void rxi4_int ( void )
{
    unsigned char   tmp;

    tmp = SCI4.RDR;                                /* Receive Data                     */
    tmp = SCI4.SSR.BIT.RDRF;
    SCI4.SSR.BIT.RDRF = 0;
}

/* ---------- SCI1 1M ---------- */
unsigned char IN_DAT4(void)
{
	while ((SCI4.SSR.BYTE & 0x78) == 0);
	if ((SCI4.SSR.BYTE & 0x40) != 0)
	{
		SCI4.SSR.BIT.RDRF = 0;		/* CLEAR RDRF */
		return SCI4.RDR;
	}
	else
	{
		OUT_DAT4(SCI4.SSR.BYTE);
		SCI4.SSR.BYTE = 0x80;	/* CLEAR ERR FLAG */
		return 0;
	}
}

/************************************************************/
/*  SCI_4 TXI4 Interrupt                                    */
/************************************************************/
void txi4_int ( void )
{
    unsigned char   tmp;

    tmp = SCI4.SSR.BIT.TDRE;
    SCI4.SSR.BIT.TDRE = 0;
}

/************************************************************/
/*  SCI_4 ERI4 Interrupt                                    */
/************************************************************/
void eri4_int ( void )
{
    unsigned char   tmp;

    tmp = SCI4.SSR.BYTE;
    SCI4.SSR.BYTE &= 0x87;                                  /* SSR ORER,PER,FER = 0 clear       */
    while(1);
}

/************************************************************/
/*  SCI_4 TEI4 Interrupt                                    */
/************************************************************/
void tei4_int ( void )
{
    SCI4.SCR.BIT.TE = 0;                                    /* TE=0                             */
    SCI4.SCR.BIT.TEIE = 0;                                  /* TEIE=0                           */
}

void	int_dummy(void)
{
}

